
	
	Program beyer_swinehart
C! density of vibrational states by 
C! Beyer-Swinehart algorithm
	implicit none
	integer(2), parameter :: MODES=15
	integer(2), parameter :: points=5000
	integer(2) ::  vibr_freq(MODES) 
	integer(2):: vibr_degen(MODES)
	integer i,j
	integer(2):: start_frequency=0
	real(8) n(0:points)
	real(8) g(0:points),x,y
	real :: energy_scale=2.  
c!energy_scale equals spacing for energy bins IN cm-1
	data vibr_freq /111,409,851,1067,1099,
	1 1295,1527,1589,1618,1625,3123,
	2 3193,3229,3268,3373/
C	data vibr_freq /409,432,863,895,
C	1 996,1026,1305,1328,1583,1682,
C	2 3278,3365,3392/

	data vibr_degen/ 15*1/

	do 5 i=1,MODES
	vibr_freq(i)=vibr_freq(i)/energy_scale
    5	enddo
	start_frequency=start_frequency/energy_scale
C! next initialize arrays
	do 2 i=1,points
	n(i)=0
	g(i)=1
   2	enddo
	n(0)=1
	g(0)=1
c! count the number of modes
	do 10 j=1,MODES
	 do 9 i=vibr_freq(j),points
	  n(i)=n(i)+n(i-vibr_freq(j))*vibr_degen(j)
	  g(i)=g(i)+g(i-vibr_freq(j))*vibr_degen(j)

	 if(mod(i,500).eq.0)write(*,*)i,n(i)
  9	enddo	
   10	enddo
	n(0)=0.
c! next write data in format for microsoft Excel, lotus
	open(unit=8,file="statedens.csv",status="replace",action="write")
	write(8,101)
	write(8,102)
  101	format("'E', 'E','N(E)','G(E)'")
  102 format("'cm-1/molecule','kcal/mole','/cm-1','dimensionless'")
	do 20 i=start_frequency,points,100
	x=i*energy_scale
	y=x*2.859e-3
	n(i)=n(i)/energy_scale
	g(i)=g(i)-1.0
	write(8,100)x,y,n(i),g(i)
  20	enddo
 100	format(f9.1,', ',f9.3,',  ',e15.7,', ',e15.7)
	stop
	end

